jersey.repackaged.org.objectweb.asm

## Class Attribute

- java.lang.Object
- - jersey.repackaged.org.objectweb.asm.Attribute

    public class Attribute
    extends Object

A non standard class, field, method or code attribute, as defined in the Java Virtual Machine Specification (JVMS).

Author:
  Eric Bruneton, Eugene Kuleshov
See Also:
  JVMS 4.7, JVMS 4.7.3

### Field Summary

Fields
`String` `type` The type of this attribute, also called its name in the JVMS.

### Constructor Summary

Constructors
`protected` `Attribute(String type)` Constructs a new empty attribute.

### Method Summary

All Methods Instance Methods Concrete Methods
`protected Label[]` `getLabels()` Returns the labels corresponding to this attribute.
`boolean` `isCodeAttribute()` Returns true if this type of attribute is a code attribute.
`boolean` `isUnknown()` Returns true if this type of attribute is unknown.
`protected Attribute` `read(ClassReader classReader, int offset, int length, char[] charBuffer, int codeAttributeOffset, Label[] labels)` Reads a `type` attribute.
`protected ByteVector` `write(ClassWriter classWriter, byte[] code, int codeLength, int maxStack, int maxLocals)` Returns the byte array form of the content of this attribute.

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Field Detail

#### type

    public final String type

The type of this attribute, also called its name in the JVMS.

### Constructor Detail

#### Attribute

    protected Attribute(String type)

Constructs a new empty attribute.

Parameters:
  `type` - the type of the attribute.

### Method Detail

#### isUnknown

    public boolean isUnknown()

Returns true if this type of attribute is unknown. This means that the attribute content can't be parsed to extract constant pool references, labels, etc. Instead, the attribute content is read as an opaque byte array, and written back as is. This can lead to invalid attributes, if the content actually contains constant pool references, labels, or other symbolic references that need to be updated when there are changes to the constant pool, the method bytecode, etc. The default implementation of this method always returns true.

Returns:
  true if this type of attribute is unknown.

#### isCodeAttribute

    public boolean isCodeAttribute()

Returns true if this type of attribute is a code attribute.

Returns:
  true if this type of attribute is a code attribute.

#### getLabels

    protected Label[] getLabels()

Returns the labels corresponding to this attribute.

Returns:
  the labels corresponding to this attribute, or null if this attribute is not a code attribute that contains labels.

#### read

    protected Attribute read(ClassReader classReader,
                             int offset,
                             int length,
                             char[] charBuffer,
                             int codeAttributeOffset,
                             Label[] labels)

Reads a `type` attribute. This method must return a new `Attribute` object, of type `type`, corresponding to the 'length' bytes starting at 'offset', in the given ClassReader.

Parameters:
  `classReader` - the class that contains the attribute to be read.
  `offset` - index of the first byte of the attribute's content in `ClassReader`. The 6 attribute header bytes (attribute_name_index and attribute_length) are not taken into account here.
  `length` - the length of the attribute's content (excluding the 6 attribute header bytes).
  `charBuffer` - the buffer to be used to call the ClassReader methods requiring a 'charBuffer' parameter.
  `codeAttributeOffset` - index of the first byte of content of the enclosing Code attribute in `ClassReader`, or -1 if the attribute to be read is not a code attribute. The 6 attribute header bytes (attribute_name_index and attribute_length) are not taken into account here.
  `labels` - the labels of the method's code, or null if the attribute to be read is not a code attribute.
Returns:
  a new `Attribute` object corresponding to the specified bytes.

#### write

    protected ByteVector write(ClassWriter classWriter,
                               byte[] code,
                               int codeLength,
                               int maxStack,
                               int maxLocals)

Returns the byte array form of the content of this attribute. The 6 header bytes (attribute_name_index and attribute_length) must not be added in the returned ByteVector.

Parameters:
  `classWriter` - the class to which this attribute must be added. This parameter can be used to add the items that corresponds to this attribute to the constant pool of this class.
  `code` - the bytecode of the method corresponding to this code attribute, or null if this attribute is not a code attribute. Corresponds to the 'code' field of the Code attribute.
  `codeLength` - the length of the bytecode of the method corresponding to this code attribute, or 0 if this attribute is not a code attribute. Corresponds to the 'code_length' field of the Code attribute.
  `maxStack` - the maximum stack size of the method corresponding to this code attribute, or -1 if this attribute is not a code attribute.
  `maxLocals` - the maximum number of local variables of the method corresponding to this code attribute, or -1 if this attribute is not a code attribute.
Returns:
  the byte array form of this attribute.